# Trình Biên Dịch Tích Hợp IDE Không Phải Là Lựa Chọn Duy Nhất (Kỳ 2)


Kỳ trước chúng ta đã tìm hiểu cơ bản về quy trình làm việc của trình biên dịch C, hiểu rõ IDE vận hành ra sao để điều khiển trình biên dịch sinh mã. Với các IDE truyền thống, chúng là những "đại công cụ" khổng lồ tích hợp cùng lúc bốn thành phần chủ chốt: trình soạn thảo, quản lý dự án, trình biên dịch và gỡ lỗi. Trong đó điểm sáng nhất của IDE là tự động hóa việc tổ chức mã nguồn, thiết lập mối quan hệ giữa các thành phần và gọi trình biên dịch xây dựng dự án.

#### Quản lý dự án bằng Batch file

Với các dự án nhỏ như bài tập ở trường, việc tạo một file make.bat để quản lý mã C là hoàn toàn khả thi. Nếu sử dụng các trình soạn thảo kiểu Windows như EditPlus, bạn có thể cấu hình "công cụ người dùng" để một phím nóng kích hoạt .bat xây dựng chương trình. Tính năng bắt đầu ra lỗi biên dịch cũng rất tiện lợi - chỉ cần nhấp đúp vào thông báo lỗi là tự động nhảy đến dòng mã lỗi.

#### Chuyển đổi sang thao tác bàn phím

Để thoát khỏi việc dùng chuột, trình soạn thảo Vim là lựa chọn lý tưởng. Đừng ngại học công cụ mới - bất kỳ công cụ nào được cộng đồng công nhận đều đáng để đầu tư thời gian. Vim có ngưỡng học tập cao nhưng hiệu quả khi thành thạo (thường cần khoảng một tuần luyện tập). Đồng nghiệp của tôi cực kỳ ưa chuộng Emacs dù tôi chưa từng sử dụng sâu. Nếu bạn dự định theo nghề lập trình hơn 10 năm, việc đầu tư vài ngày học công cụ hàng ngàn lập trình viên đánh giá cao là khoản đầu tư khôn ngoan.

#### Giới hạn của Batch file

Khi dự án mở rộng, cách dùng .bat bắt đầu lộ hạn chế vì mỗi lần build đều phải biên dịch lại toàn bộ. Trong khi đó, thiết kế C/C++ cho phép biên dịch từng file độc lập rồi kết nối chúng sau. Hãy thử biên dịch riêng từng file và chỉ liên kết lại khi cần thiết.

#### Quy trình biên dịch cơ bản

Hầu hết trình biên dịch C chia thành hai giai đoạn: biên dịch và liên kết. Với Microsoft CL hay GCC, bạn có thể dùng tham số /c (-c với GCC) để chỉ biên dịch riêng từng file. Ví dụ:
```
cl /c foo.c
```
Sẽ tạo ra foo.obj. Tương tự cho bar.obj, sau đó liên kết bằng:
```
link /out:foobar.exe foo.obj bar.obj
```

#### Vai trò của lập trình viên

Quy trình xây dựng chương trình có thể chia thành ba bước rõ ràng:
1. Dạy máy cách biên dịch .c thành .obj
2. Dạy máy cách liên kết .obj thành .exe
3. Cung cấp danh sách .c và tên .exe đầu ra

Hai bước đầu thường chung cho mọi dự án, vì vậy chỉ cần dạy máy một lần. Điều này mở ra nhu cầu sử dụng công cụ tự động hóa.

#### Công cụ Make - Bậc thầy tự động hóa

Make là cột mốc quan trọng trong hành trình tự động hóa. Với quy tắc đơn giản, nó giúp quản lý phụ thuộc giữa các thành phần và tự động thực hiện các bước theo thứ tự đúng. Bạn chỉ cần xác định:
- Các thành phần phụ thuộc lẫn nhau như thế nào
- Cách xây dựng từng thành phần

Ví dụ, Makefile đầu tiên của bạn có thể là:
```
all:
	@echo "Xin chao The Gioi"
```
Chú ý phải dùng Tab (không phải khoảng trắng) ở đầu dòng lệnh.

#### Tối ưu hóa quy trình biên dịch

Hãy thử biến Make thành trợ lý biên dịch:
```
foobar.exe: foo.c bar.c
	cl /Fe$@ $^
```
Khi chạy gmake foobar.exe, công cụ sẽ tự động kiểm tra thời gian sửa đổi các file nguồn và chỉ biên dịch khi cần thiết.

#### Sức mạnh thực sự của Make

Điều khiến Make trở nên đặc biệt là khả năng quản lý phụ thuộc thông minh. Khi bạn sửa đổi foo.c, Make tự động nhận diện và kích hoạt lại quá trình xây dựng. Bạn có thể mở rộng Makefile để tích hợp các nhiệm vụ phức tạp:
- Tự động chạy test
- Xây dựng tài liệu
- Triển khai bản cài đặt
- Tối ưu hóa hiệu năng

#### Bước tiếp theo

Hiểu rõ nguyên lý hoạt động của Make giúp bạn làm chủ nhiều công cụ xây dựng hiện đại như CMake, Gradle hay Bazel. Hãy tiếp tục khám phá các khái niệm quan trọng:
- Biến trong Make ($@, $^, $<)
- Quy tắc ngầm định (implicit rules)
- Mẫu định nghĩa (pattern rules)
- Phân tích phụ thuộc tự động

Cộng đồng lập trình có câu: "Lập trình là nghệ thuật dạy máy tính làm việc thay mình". Hãy dùng Make để biến nghệ thuật đó thành hiện thực. Kỳ sau chúng ta sẽ cùng xây dựng một hệ thống xây dựng hoàn chỉnh với Makefile chuyên nghiệp.

Hãy bắt đầu từ những bước nhỏ nhất - mở trình soạn thảo, tạo file Makefile đầu tiên và gõ dòng lệnh "gmake all" đầu tiên của bạn!

---

> Tác giả:   
> URL: http://apkpm.com/posts/09/replacement_of_ide_2/  

